<?php 

/** 

Class derived from EasyPhpThumbnail Class 
Copyright (c) 2008-2014 JF Nutbroek <jfnutbroek@gmail.com>

Permission to use, copy, modify, and/or distribute this software for any
purpose without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

*/

class easyphpthumbnail {
		
	public  $Thumbsize;			
	public  $Chmodlevel;	
	public  $Thumblocation;
	public  $Quality;
	private $image;			
	private $im;			
	private $thumb;			
	private $size;
	private $thumbx;				
	private $thumby;
	private $memsize;

	public function __construct() {
	
		$this -> Thumbsize           =  140;
		$this -> Chmodlevel          =  '0755';
		$this -> Thumblocation       =  '';
		$this -> Quality             =  '90';
		$this -> memsize             =  $this -> return_bytes(ini_get('memory_limit')) * 0.55 - ($this -> Thumbsize * $this -> Thumbsize * 4);
		
	}
	
	public function __destruct() {
        
		if(is_resource($this -> im)) imagedestroy($this -> im);
		if(is_resource($this -> thumb)) imagedestroy($this -> thumb);
        
	}
	
	public function Createthumb($filename = "unknown") {

			$this -> image = $filename;
			$this -> thumbmaker();
                
	}

	private function thumbmaker() {

		if ($this -> loadimage()) {
			$this -> createemptythumbnail();
			imagecopyresampled($this -> thumb,$this -> im, 0, 0, 0, 0, $this -> thumbx,$this -> thumby,imagesx($this -> im),imagesy($this -> im));
			$this -> savethumb();
		}
                
	}
        
	private function loadimage() {
	
		if (file_exists($this -> image)) {
			$this -> size = getimagesize($this -> image);
			if ($this -> memsize>0) {
					if (($this -> size[0]*$this -> size[1]*4)>$this -> memsize) {return false;}
			}
			switch($this -> size[2]) {
				case 1:
					if (imagetypes() & IMG_GIF) {$this -> im = imagecreatefromgif($this -> image);} 
					break;
				case 2:
					if (imagetypes() & IMG_JPG) {$this -> im = imagecreatefromjpeg($this -> image);} 
					break;
				case 3:
					if (imagetypes() & IMG_PNG) {$this -> im = imagecreatefrompng($this -> image);} 
					break;
				default:
					return false;
			}
			if (!$this -> im) {return false;} else {return true;}
		} else {
			return false;	
		}  
      
	}

	private function createemptythumbnail() {
        
		if ($this -> size[0]>$this -> size[1])
			$this -> thumb = imagecreatetruecolor($this -> Thumbsize, ceil($this -> size[1]/($this -> size[0]/$this -> Thumbsize)));
		else
			$this -> thumb = imagecreatetruecolor(ceil($this -> size[0]/($this -> size[1]/$this -> Thumbsize)), $this -> Thumbsize);
		$this -> thumbx = imagesx($this -> thumb);
		$this -> thumby = imagesy($this -> thumb);

	}
        
	private function savethumb() {
        
		$this -> image = substr($this -> image, 0, strrpos($this -> image, '.')) . ".jpg";
		imagejpeg($this -> thumb, $this -> Thumblocation . basename($this -> image), $this -> Quality);
		if ($this -> Chmodlevel != '') {chmod($this -> Thumblocation . basename($this -> image), octdec($this -> Chmodlevel));}
		imagedestroy($this -> im);
		imagedestroy($this -> thumb);
                
	}
	
	private function return_bytes($size_str) {
	
		switch (substr ($size_str, -1)) {
			case 'M': case 'm': return (int)$size_str * 1048576;
			case 'K': case 'k': return (int)$size_str * 1024;
			case 'G': case 'g': return (int)$size_str * 1073741824;
			default: return intval($size_str);
		}
		
	}
  
}

?>
